// Generated by gmmproc 2.56.0 -- DO NOT MODIFY!


#include <glibmm.h>

#include <atkmm/streamablecontent.h>
#include <atkmm/private/streamablecontent_p.h>


// -*- c++ -*-
/* $Id: streamablecontent.ccg,v 1.1 2004/01/02 09:56:43 murrayc Exp $ */

/* Copyright 2003 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <atkmm/object.h>
#include <atk/atkstreamablecontent.h>


namespace Atk
{


} // namespace Atk


namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Atk::StreamableContent> wrap(AtkStreamableContent* object, bool take_copy)
{
  return Glib::RefPtr<Atk::StreamableContent>( dynamic_cast<Atk::StreamableContent*> (Glib::wrap_auto_interface<Atk::StreamableContent> ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} // namespace Glib


namespace Atk
{


/* The *_Class implementation: */

const Glib::Interface_Class& StreamableContent_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Interface_Class has to know the interface init function
    // in order to add interfaces to implementing types.
    class_init_func_ = &StreamableContent_Class::iface_init_function;

    // We can not derive from another interface, and it is not necessary anyway.
    gtype_ = atk_streamable_content_get_type();
  }

  return *this;
}

void StreamableContent_Class::iface_init_function(void* g_iface, void*)
{
  const auto klass = static_cast<BaseClassType*>(g_iface);

  //This is just to avoid an "unused variable" warning when there are no vfuncs or signal handlers to connect.
  //This is a temporary fix until I find out why I can not seem to derive a GtkFileChooser interface. murrayc
  g_assert(klass != nullptr);

  klass->get_n_mime_types = &get_n_mime_types_vfunc_callback;
  klass->get_mime_type = &get_mime_type_vfunc_callback;
  klass->get_stream = &get_stream_vfunc_callback;

}

int StreamableContent_Class::get_n_mime_types_vfunc_callback(AtkStreamableContent* self)
{
  const auto obj_base = static_cast<Glib::ObjectBase*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj_base && obj_base->is_derived_())
  {
    const auto obj = dynamic_cast<CppObjectType* const>(obj_base);
    if(obj) // This can be NULL during destruction.
    {
      try // Trap C++ exceptions which would normally be lost because this is a C callback.
      {
        // Call the virtual member method, which derived classes might override.
        return obj->get_n_mime_types_vfunc();
      }
      catch(...)
      {
        Glib::exception_handlers_invoke();
      }
    }
  }

  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_interface_peek_parent( // Get the parent interface of the interface (The original underlying C interface).
g_type_interface_peek(G_OBJECT_GET_CLASS(self), CppObjectType::get_type()) // Get the interface.
)  );

  // Call the original underlying C function:
  if(base && base->get_n_mime_types)
    return (*base->get_n_mime_types)(self);

  using RType = int;
  return RType();
}
const gchar* StreamableContent_Class::get_mime_type_vfunc_callback(AtkStreamableContent* self, gint i)
{
  const auto obj_base = static_cast<Glib::ObjectBase*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj_base && obj_base->is_derived_())
  {
    const auto obj = dynamic_cast<CppObjectType* const>(obj_base);
    if(obj) // This can be NULL during destruction.
    {
      try // Trap C++ exceptions which would normally be lost because this is a C callback.
      {
        // Call the virtual member method, which derived classes might override.
        return obj->get_mime_type_vfunc(i
);
      }
      catch(...)
      {
        Glib::exception_handlers_invoke();
      }
    }
  }

  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_interface_peek_parent( // Get the parent interface of the interface (The original underlying C interface).
g_type_interface_peek(G_OBJECT_GET_CLASS(self), CppObjectType::get_type()) // Get the interface.
)  );

  // Call the original underlying C function:
  if(base && base->get_mime_type)
    return (*base->get_mime_type)(self, i);

  using RType = const gchar*;
  return RType();
}
GIOChannel* StreamableContent_Class::get_stream_vfunc_callback(AtkStreamableContent* self, const gchar* mime_type)
{
  const auto obj_base = static_cast<Glib::ObjectBase*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj_base && obj_base->is_derived_())
  {
    const auto obj = dynamic_cast<CppObjectType* const>(obj_base);
    if(obj) // This can be NULL during destruction.
    {
      try // Trap C++ exceptions which would normally be lost because this is a C callback.
      {
        // Call the virtual member method, which derived classes might override.
        return obj->get_stream_vfunc(Glib::convert_const_gchar_ptr_to_ustring(mime_type)
);
      }
      catch(...)
      {
        Glib::exception_handlers_invoke();
      }
    }
  }

  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_interface_peek_parent( // Get the parent interface of the interface (The original underlying C interface).
g_type_interface_peek(G_OBJECT_GET_CLASS(self), CppObjectType::get_type()) // Get the interface.
)  );

  // Call the original underlying C function:
  if(base && base->get_stream)
    return (*base->get_stream)(self, mime_type);

  using RType = GIOChannel*;
  return RType();
}


Glib::ObjectBase* StreamableContent_Class::wrap_new(GObject* object)
{
  return new StreamableContent((AtkStreamableContent*)(object));
}


/* The implementation: */

StreamableContent::StreamableContent()
:
  Glib::Interface(streamablecontent_class_.init())
{}

StreamableContent::StreamableContent(AtkStreamableContent* castitem)
:
  Glib::Interface((GObject*)(castitem))
{}

StreamableContent::StreamableContent(const Glib::Interface_Class& interface_class)
: Glib::Interface(interface_class)
{
}

StreamableContent::StreamableContent(StreamableContent&& src) noexcept
: Glib::Interface(std::move(src))
{}

StreamableContent& StreamableContent::operator=(StreamableContent&& src) noexcept
{
  Glib::Interface::operator=(std::move(src));
  return *this;
}

StreamableContent::~StreamableContent() noexcept
{}

// static
void StreamableContent::add_interface(GType gtype_implementer)
{
  streamablecontent_class_.init().add_interface(gtype_implementer);
}

StreamableContent::CppClassType StreamableContent::streamablecontent_class_; // initialize static member

GType StreamableContent::get_type()
{
  return streamablecontent_class_.init().get_type();
}


GType StreamableContent::get_base_type()
{
  return atk_streamable_content_get_type();
}


int StreamableContent::get_n_mime_types() const
{
  return atk_streamable_content_get_n_mime_types(const_cast<AtkStreamableContent*>(gobj()));
}

Glib::ustring StreamableContent::get_mime_type(int i) const
{
  return Glib::convert_const_gchar_ptr_to_ustring(atk_streamable_content_get_mime_type(const_cast<AtkStreamableContent*>(gobj()), i));
}

Glib::RefPtr<Glib::IOChannel> StreamableContent::get_stream(const Glib::ustring& mime_type)
{
  return Glib::wrap(atk_streamable_content_get_stream(gobj(), mime_type.c_str()));
}


int Atk::StreamableContent::get_n_mime_types_vfunc() const
{
  const auto base = static_cast<BaseClassType*>(
      g_type_interface_peek_parent( // Get the parent interface of the interface (The original underlying C interface).
g_type_interface_peek(G_OBJECT_GET_CLASS(gobject_), CppObjectType::get_type()) // Get the interface.
)  );

  if(base && base->get_n_mime_types)
  {
    int retval((*base->get_n_mime_types)(const_cast<AtkStreamableContent*>(gobj())));
    return retval;
  }

  using RType = int;
  return RType();
}
const gchar* Atk::StreamableContent::get_mime_type_vfunc(int i) const
{
  const auto base = static_cast<BaseClassType*>(
      g_type_interface_peek_parent( // Get the parent interface of the interface (The original underlying C interface).
g_type_interface_peek(G_OBJECT_GET_CLASS(gobject_), CppObjectType::get_type()) // Get the interface.
)  );

  if(base && base->get_mime_type)
  {
    const gchar* retval((*base->get_mime_type)(const_cast<AtkStreamableContent*>(gobj()),i));
    return retval;
  }

  using RType = const gchar*;
  return RType();
}
GIOChannel* Atk::StreamableContent::get_stream_vfunc(const Glib::ustring& mime_type) 
{
  const auto base = static_cast<BaseClassType*>(
      g_type_interface_peek_parent( // Get the parent interface of the interface (The original underlying C interface).
g_type_interface_peek(G_OBJECT_GET_CLASS(gobject_), CppObjectType::get_type()) // Get the interface.
)  );

  if(base && base->get_stream)
  {
    GIOChannel* retval((*base->get_stream)(gobj(),mime_type.c_str()));
    return retval;
  }

  using RType = GIOChannel*;
  return RType();
}


} // namespace Atk


